<style scoped>
.redmark {
  color: #ffd900;
  background: #000000;
  padding: 4px;
  border-radius: 4px;
}
.orangemark {
  color: #ffffff;
  background: #ff3d3d;
  padding: 4px;
  border-radius: 4px;
}
.blackmark {
  color: #363636;
  background: #ffffff;
  border: 1px solid #363636;
  padding: 2px;
  border-radius: 2px;
}
</style>
<template>
  <div>
    <Spin fix v-show="loadingtype">
      <Icon type="ios-loading" size="18" class="demo-spin-icon-load"></Icon>
      <div>{{ $t('loading') }}</div>
    </Spin>
    <h1 class="tc mb-10">
      <Icon type="ios-contacts" />
      {{ $t('administrator.title') }}
    </h1>
    <table width="100%">
      <thead>
        <tr>
          <th colspan="15">{{ $t('memeber.thtitle') }}</th>
        </tr>
        <tr>
          <th width="5%">{{ $t('memeber.th4') }}</th>
          <th width="10%">{{ $t('memeber.th5') }}</th>
          <th width="10%">{{ $t('memeber.th6') }}</th>
          <th width="12.5%">{{ $t('memeber.th9') }}</th>
          <th width="12.5%">{{ $t('memeber.th8') }}</th>
          <th width="12.5%">{{ $t('memeber.th12') }}</th>
          <th width="12.5%">{{ $t('memeber.th11') }}</th>
          <th width="15%">{{ $t('administrator.Memberlevel') }}</th>
          <th width="10%">{{ $t('administrator.action') }}</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(it,index) in historyData" :key="index+'pay'" class="tc">
          <td>{{it.sex}}</td>
          <td>{{it.birth}}</td>
          <td>
            <b>{{it.displayName}}</b>
          </td>
          <td>{{it.langs}}</td>
          <td>{{it.live}}</td>
          <td>{{it.country}}</td>
          <td>{{it.work}}</td>
          <td>
            <font v-if="it.lv=='3'" class="tc">
              <b class="mr-15 blackmark">
                <Icon type="ios-person" />
                {{ $t('administrator.normalmember') }}
              </b>
            </font>
            <font v-if="it.lv=='2'" class="tc">
              <b class="mr-25 orangemark">
                <Icon type="ios-person" />
                {{ $t('administrator.administrator') }}
              </b>
            </font>
            <b v-if="it.lv=='1'" class="redmark">
              <Icon type="ios-ribbon" />
              {{ $t('administrator.boss') }}
            </b>
          </td>
          <td>
            <font v-if="it.lv=='3'" class="tc">
              <Button type="primary" size="small" @click="chglvconfirm('2',it.id)">
                {{ $t('administrator.chglv') }}
                <Icon type="ios-construct" />
              </Button>
            </font>
            <font v-if="it.lv=='2'" class="tc">
              <Button type="primary" size="small" @click="chglvconfirm('3',it.id)">
                {{ $t('administrator.chglv') }}
                <Icon type="ios-construct" />
              </Button>
            </font>
          </td>
        </tr>
        <tr v-if="tabledata==''">
          <td colspan="10" class="tc">無資料</td>
        </tr>
      </tbody>
    </table>
    <Page
      ref="pages"
      class="fr m-20"
      :total="dataCount"
      :page-size="pageSize"
      simple
      @on-change="changepage"
    ></Page>
    <Divider />
  </div>
</template>

<script>
import moment from "moment";
import firebase from "firebase/app";;
export default {
  middleware: "routerAuth",
  data() {
    return {
      tabledata: "尚未有資料",
      acount: [],
      ajaxHistoryData: [],
      // 初始化信息总条数
      dataCount: 0,
      // 每页显示多少条
      pageSize: 10,
      historyData: [],
      loadingtype: false
    };
  },
  async asyncData(context) {
    const db = firebase.firestore();
    const ref = db.collection("member");
    var result = [];
    await ref.orderBy("birth", "asc").onSnapshot(querySnapshot => {
      querySnapshot.docChanges().forEach(change => {
        if (change.type === "added") {
          var resultdata = [];
          // console.log("New: ", change.doc.data());
          resultdata = change.doc.data();
          resultdata.keypayback = change.doc.id;
          result.push(resultdata);
        }
        if (change.type === "modified") {
          // console.log("Modified: ", change.doc.data());
          resultdata = change.doc.data();
          resultdata.keypayback = change.doc.id;
          const fixobj = result.findIndex(item=>item.id == resultdata.id)
          // console.log(`fixobj`, fixobj);
          result[fixobj] = resultdata;
        }
        if (change.type === "removed") {
          // console.log("Removed: ", change.doc.data());
        }
      });
    }),
      error => {
        console.log(`err`, err);
      };
    return { tabledata: result };
  },
  created() {
    this.handleListApproveHistory();
  },
  watch: {
    tabledata(val) {
      this.handleListApproveHistory();
    }
  },
  methods: {
    // 获取历史记录信息
    handleListApproveHistory() {
      // 保存取到的所有数据
      this.ajaxHistoryData = this.tabledata;
      this.dataCount = this.tabledata.length;
      // 初始化显示，小于每页显示条数，全显，大于每页显示条数，取前每页条数显示
      if (this.tabledata.length < this.pageSize) {
        this.historyData = this.ajaxHistoryData;
      } else {
        this.historyData = this.ajaxHistoryData.slice(0, this.pageSize);
      }
      this.$nextTick(() => {
        this.$refs["pages"].currentPage = 1;
      });
    },
    changepage(index) {
      var _start = (index - 1) * this.pageSize;
      var _end = index * this.pageSize;
      this.historyData = this.ajaxHistoryData.slice(_start, _end);
    },
    chglv(getlv, data) {
      this.loadingtype = !this.loadingtype;
      const stata = { lv: getlv };
      const db = firebase.firestore();
      const ref1 = db.doc("member/" + data);
      ref1.update(stata).then(data => {
        this.loadingtype = !this.loadingtype;
      });
    },
    chglvconfirm(getlv, data) {
      this.$Modal.confirm({
        title: this.$t("administrator.chglv"),
        content: "<p>" + this.$t("administrator.lvchg") + "</p>",
        onOk: () => {
          this.chglv(getlv, data);
        },
        onCancel: () => {
          this.$Message.info(this.$t("administrator.cancelchg"));
        }
      });
    },
    test() {
      const stata = {
        birth: "0570204",
        country: "立陶宛",
        displayName: "橋本漢堡",
        id: "D9SuWiCzOQSQOc5g42RRQsbqKS42",
        langs: "台語",
        live: "屏東縣",
        lv: "3",
        phone: "0924681011",
        school: "高中",
        sex: "男",
        work: "工程師"
      };
      const key = "D9SuWiCzOQSQOc5g42RRQsbqKS42";
      const db = firebase.firestore();
      const ref = db.doc("member/" + key);
      ref.update(stata);
    }
  }
};
</script>